; Ficheiro: control4.asm
;
; By:       Rui Loureiro
;
        .586                        ; directiva para o compilador usar instrues x586
        .model flat, stdcall        ; directiva: modelo flat, standard call
        option casemap:none         ; directiva: case sensitive
    
; ####################################################
        ; 
        ;      Constantes e macros
        ; 
        include \masm32\include\windows.inc
        include \masm32\macros\macros.asm

        ; 
        ;   Prototipos de procs Windows
        ; 
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\comctl32.inc
        
        ; 
        ; Bibliotecas de procedimentos Windows
        ; 
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib
        includelib \masm32\lib\comctl32.lib
    
; ####################################################

        ; 
        ; constantes definidas em rsrc.rc (ficheiro de recursos)
        ; 
        IDC_SPIN1 equ 500
        IDC_EDIT1 equ 501
        IDC_EXIT  equ 502
; --------------------------------------------------------
        DlgUpDn    proto :DWORD,:DWORD,:DWORD,:DWORD
; --------------------------------------------------------
; 
; Seco da DADOS: .data: variveis inicializadas (ou com ? so colocadas a 0)
; 
.data
_hInstance      dd ?

_MaxPosition    dd 0
_NewPosition    dd 0
    
_Dlgname        db "MUSICAS", 0     ; o nome definido em rsrc.rc  MUSICAS     

; 
; Seco da DADOS: data?: variveis NO inicializadas (s com ?)
; 
.data?
_icex           INITCOMMONCONTROLSEX <?>    ; _icex  o endereo de uma estrutura
_ErrUpDn        dd ?     
; ###############################################################
; 
; Seco de Cdigo comea aqui e no endereo _start e vai terminar com end _start
; 
.code
    
_start:
    
; ###############################################################
    
        invoke  GetModuleHandle, NULL
        mov     _hInstance, eax
        
        ; 
        ; Inicializa a estrutura em _icex e carrega na memoria
        ; a dll onde esto os procs que vamos usar
        ; 
        mov     _icex.dwSize, sizeof INITCOMMONCONTROLSEX
        mov     _icex.dwICC, 0FFFFh
        invoke  InitCommonControlsEx, addr _icex

        mov     _NewPosition, 1             ; valor inicial
        mov     _MaxPosition, 100           ; valor final
    
        ; 
        ; Chama a "dialog box" definida no ficheiro de recursos rsrc.rc
        ; 
        invoke  DialogBoxParam, _hInstance, addr _Dlgname, 0, addr DlgUpDn, 0

        ; 
        ; Termina o programa e sai fora
        ; 
        invoke  ExitProcess, eax
    
; ###############################################################
DlgUpDn     proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

            mov     ebx, wParam
            
        SWITCH  uMsg
        CASE    WM_INITDIALOG

            ; 
            ; Estabelece os limites entre 1 e _MaxPosition
            ; 
            invoke SendDlgItemMessage, hWnd, IDC_SPIN1, UDM_SETRANGE32, 1, _MaxPosition

            ; 
            ; Comea na posio _NewPosition
            ; 
            invoke SendDlgItemMessage, hWnd, IDC_SPIN1, UDM_SETPOS32, 1, _NewPosition

            invoke SetFocus, hWnd
    
        CASE    WM_CLOSE

            invoke  SendDlgItemMessage, hWnd, IDC_SPIN1, UDM_GETPOS32, 0, addr _ErrUpDn

            cmp     _ErrUpDn, 0
            jne     short @F            ; erro

            mov     _NewPosition, eax
@@:
            invoke EndDialog, hWnd, NULL

        CASE    WM_COMMAND
        
            mov     edx, ebx
		shr     edx, 16
            and     ebx, 0FFFFh
            
            switch  edx
            case    BN_CLICKED
            
                .if ebx == IDC_EXIT
                    invoke    SendMessage, hWnd, WM_CLOSE, NULL, NULL
                .endif
            endsw
            
        CASE    WM_VSCROLL
        
                and     ebx, 0FFFFh

                ; 
                ;           Decrementa
                ;   
                cmp     ebx, SB_LINEUP
                jne     short _next
                
                    mov     edx, _MaxPosition
                    
                    cmp     _NewPosition, 1
                    je      short _new
                    
                    mov     edx, _NewPosition
                    sub     edx, 1
                    jmp     short _new

                ; 
                ;           Incrementa
                ; 
_next:          cmp     ebx, SB_LINEDOWN
                jne     short _exit
                
                    mov     edx, 1
                    mov     eax, _MaxPosition
                    cmp     eax, _NewPosition
                    je      short _new
                    
                    mov     edx, _NewPosition
                    add     edx, 1
                    
_new:               mov    _NewPosition, edx
                    
                ; 
                ; Set to the position in _NewPosition
                ; 
_end:           invoke SendDlgItemMessage, hWnd, IDC_SPIN1, UDM_SETPOS32, 0, _NewPosition

        ENDSW
    
_exit:      xor     eax, eax
            ret
DlgUpDn    endp
; ###############################################################
end _start
